// MPDUpdateDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MPDUpdate.h"
#include "MPDUpdateDlg.h"
#include "mpd.h"
#include "bsocket.h"
#include "crypt.h"
#include <tchar.h>
#include "PwdDialog.h"
#include <afxinet.h>
#include "mpdutil.h"
#include "launchprocess.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DEFAULT_LAUNCH_TIMEOUT 7

bool GetLocalVersion(const char *filename, unsigned int &version);

/////////////////////////////////////////////////////////////////////////////
// CMPDUpdateDlg dialog

CMPDUpdateDlg::CMPDUpdateDlg(CWnd* pParent /*=NULL*/)
: CDialog(CMPDUpdateDlg::IDD, pParent)
{
    m_bNeedPassword = false;
    //{{AFX_DATA_INIT(CMPDUpdateDlg)
	m_domain = _T("");
	m_password = _T("");
	m_host_config = _T("");
	m_bShowHostConfig = FALSE;
	m_filename = _T("");
	m_urlname = _T("ftp://ftp.mcs.anl.gov/pub/mpi/nt/binaries/mpd.exe");
	m_hostname = _T("");
	m_cred_account = _T("");
	m_cred_password = _T("");
	m_bForceUpdate = FALSE;
	m_results = _T("");
	//}}AFX_DATA_INIT
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_hFindThread = NULL;
    m_hUpdateBtnThread = NULL;
    m_nMinWidth = -1;
    m_nMinHeight = -1;
}

void CMPDUpdateDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CMPDUpdateDlg)
	DDX_Control(pDX, IDC_STATIC_EDIT, m_static_edit);
	DDX_Control(pDX, IDC_RESULTS, m_results_edit);
	DDX_Control(pDX, IDC_FORCE_UPDATE_CHK, m_force_update_chk);
	DDX_Control(pDX, IDC_CREDENTIALS_STATIC, m_credentials_static);
	DDX_Control(pDX, IDC_CRED_PWD_STATIC, m_cred_pwd_static);
	DDX_Control(pDX, IDC_CRED_PWD_EDIT, m_cred_password_edit);
	DDX_Control(pDX, IDC_CRED_BOX_STATIC, m_cred_box_static);
	DDX_Control(pDX, IDC_CRED_ACCOUNT_STATIC, m_cred_account_static);
	DDX_Control(pDX, IDC_CRED_ACCOUNT_EDIT, m_cred_account_edit);
	DDX_Control(pDX, IDC_UPDATE_STATIC, m_update_static);
	DDX_Control(pDX, IDC_UPDATE_ONE_STATIC, m_update_one_static);
	DDX_Control(pDX, IDC_UPDATE_ONE_BTN, m_update_one_btn);
	DDX_Control(pDX, IDC_UPDATE_BTN, m_update_btn);
	DDX_Control(pDX, IDC_SOURCE_STATIC, m_source_static);
	DDX_Control(pDX, IDC_URL_EDIT, m_url_edit);
	DDX_Control(pDX, IDC_FILE_EDIT, m_file_edit);
	DDX_Control(pDX, IDC_FILE_BROWSE_BTN, m_file_browse_btn);
	DDX_Control(pDX, IDC_ANL_BTN, m_anl_btn);
	DDX_Control(pDX, IDC_VERIFY_BTN, m_verify_btn);
	DDX_Control(pDX, IDC_SHOW_HOST_CHK, m_show_host_chk);
	DDX_Control(pDX, IDC_HOST_CONFIG, m_host_config_edit);
	DDX_Control(pDX, IDC_STOPLIGHT_YELLOW, m_stoplight_yellow);
	DDX_Control(pDX, IDC_STOPLIGHT_GREEN, m_stoplight_green);
	DDX_Control(pDX, IDC_STOPLIGHT_RED, m_stoplight_red);
	DDX_Control(pDX, IDC_TWO_STATIC, m_two_static);
	DDX_Control(pDX, IDC_PHRASE_STATIC, m_phrase_static);
	DDX_Control(pDX, IDC_ONE_STATIC, m_one_static);
	DDX_Control(pDX, IDC_PASSWORD, m_pwd_ctrl);
	DDX_Control(pDX, IDC_DOMAIN, m_domain_edit);
	DDX_Control(pDX, IDOK, m_ok_btn);
	DDX_Control(pDX, IDCANCEL, m_cancel_btn);
	DDX_Control(pDX, IDC_EDIT_ADD_BTN, m_edit_add_btn);
    DDX_Control(pDX, IDC_HOST_LIST, m_host_list);
    DDX_Control(pDX, IDC_REFRESH_BTN, m_refresh_btn);
    DDX_Control(pDX, IDC_FIND_BTN, m_find_btn);
    DDX_Control(pDX, IDC_LIST, m_list);
	DDX_Text(pDX, IDC_DOMAIN, m_domain);
	DDX_Text(pDX, IDC_PASSWORD, m_password);
	DDX_Text(pDX, IDC_HOST_CONFIG, m_host_config);
	DDX_Check(pDX, IDC_SHOW_HOST_CHK, m_bShowHostConfig);
	DDX_Text(pDX, IDC_FILE_EDIT, m_filename);
	DDX_Text(pDX, IDC_URL_EDIT, m_urlname);
	DDX_Text(pDX, IDC_HOSTNAME, m_hostname);
	DDX_Control(pDX, IDC_FILE_RADIO, m_file_radio);
	DDX_Control(pDX, IDC_URL_RADIO, m_url_radio);
	DDX_Control(pDX, IDC_PHRASE_RADIO, m_pwd_radio);
	DDX_Control(pDX, IDC_DEFAULT_RADIO, m_default_radio);
	DDX_Text(pDX, IDC_CRED_ACCOUNT_EDIT, m_cred_account);
	DDX_Text(pDX, IDC_CRED_PWD_EDIT, m_cred_password);
	DDX_Check(pDX, IDC_FORCE_UPDATE_CHK, m_bForceUpdate);
	DDX_Text(pDX, IDC_RESULTS, m_results);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMPDUpdateDlg, CDialog)
//{{AFX_MSG_MAP(CMPDUpdateDlg)
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
ON_BN_CLICKED(IDC_FIND_BTN, OnFindBtn)
ON_BN_CLICKED(IDC_REFRESH_BTN, OnRefreshBtn)
ON_BN_CLICKED(IDC_UPDATE_BTN, OnUpdateBtn)
ON_BN_CLICKED(IDC_EDIT_ADD_BTN, OnEditAddBtn)
	ON_WM_VKEYTOITEM()
	ON_WM_CLOSE()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_PHRASE_RADIO, OnPhraseRadio)
	ON_BN_CLICKED(IDC_DEFAULT_RADIO, OnDefaultPwdRadio)
	ON_BN_CLICKED(IDC_SHOW_HOST_CHK, OnShowHostChk)
	ON_LBN_SELCHANGE(IDC_HOST_LIST, OnSelchangeHostList)
	ON_BN_CLICKED(IDC_VERIFY_BTN, OnVerifyBtn)
	ON_BN_CLICKED(IDC_UPDATE_ONE_BTN, OnUpdateOneBtn)
	ON_BN_CLICKED(IDC_ANL_BTN, OnAnlBtn)
	ON_BN_CLICKED(IDC_FILE_BROWSE_BTN, OnFileBrowseBtn)
	ON_BN_CLICKED(IDC_URL_RADIO, OnURLRadio)
	ON_BN_CLICKED(IDC_FILE_RADIO, OnFileRadio)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMPDUpdateDlg message handlers

void CMPDUpdateDlg::ParseRegistry()
{
    HKEY tkey;
    DWORD result, len;
    char path[MAX_PATH];
    
    // Set the defaults.
    m_nPort = MPD_DEFAULT_PORT;
    gethostname(m_pszHost, 100);
    
    m_bNeedPassword = true;

    // Open the root key
    if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, MPD_REGISTRY_KEY,
	0, KEY_ALL_ACCESS, &tkey) != ERROR_SUCCESS)
    {
	printf("Unable to open SOFTWARE\\MPICH\\MPD registry key, error %d\n", GetLastError());
	return;
    }
    
    // Read the port
    len = sizeof(int);
    result = RegQueryValueEx(tkey, "port", 0, NULL, (unsigned char *)&m_nPort, &len);
    
    // Check to see if a passphrase has been set and set it to the default if necessary.
    len = 100;
    result = RegQueryValueEx(tkey, "phrase", 0, NULL, (unsigned char *)m_pszPhrase, &len);
    if (result == ERROR_SUCCESS)
	m_bNeedPassword = false;
    
    len = MAX_PATH;
    result = RegQueryValueEx(tkey, "path", 0, NULL, (unsigned char *)path, &len);
    if (result == ERROR_SUCCESS)
    {
	m_filename = path;
    }

    RegCloseKey(tkey);
}

BOOL CMPDUpdateDlg::OnInitDialog()
{
    HWND hWnd;
    CDialog::OnInitDialog();
    
    SetIcon(m_hIcon, TRUE);			// Set big icon
    SetIcon(m_hIcon, FALSE);		// Set small icon
    
    bsocket_init();
    ParseRegistry();

    RECT r;
    GetClientRect(&r);
    m_nMinWidth = r.right;
    m_nMinHeight = r.bottom;

    r1Static.SetInitialPosition(m_one_static.m_hWnd, RSR_STRETCH);
    rList.SetInitialPosition(m_host_list.m_hWnd, RSR_STRETCH_BOTTOM);
    rOk.SetInitialPosition(m_ok_btn.m_hWnd, RSR_MOVE);
    rCancel.SetInitialPosition(m_cancel_btn.m_hWnd, RSR_MOVE);
    rBox.SetInitialPosition(m_list.m_hWnd, RSR_STRETCH);
    rRefresh.SetInitialPosition(m_refresh_btn.m_hWnd, RSR_MOVE);
    rDomain.SetInitialPosition(m_domain_edit.m_hWnd, RSR_ANCHOR_BOTTOM);
    rStatic.SetInitialPosition(m_static_edit.m_hWnd, RSR_ANCHOR_BOTTOM);

    rSourceStatic.SetInitialPosition(m_source_static.m_hWnd, RSR_MOVE);
    GetDlgItem(IDC_FILE_RADIO, &hWnd);
    rFileRadio.SetInitialPosition(hWnd, RSR_MOVE);
    rFileName.SetInitialPosition(m_file_edit.m_hWnd, RSR_MOVE);
    rFileBrowse.SetInitialPosition(m_file_browse_btn.m_hWnd, RSR_MOVE);
    GetDlgItem(IDC_URL_RADIO, &hWnd);
    rURLRadio.SetInitialPosition(hWnd, RSR_MOVE);
    rURL.SetInitialPosition(m_url_edit.m_hWnd, RSR_MOVE);
    rANL.SetInitialPosition(m_anl_btn.m_hWnd, RSR_MOVE);

    r2Static.SetInitialPosition(m_two_static.m_hWnd, RSR_MOVE);
    /*rPwdStatic.SetInitialPosition(m_pwd_static.m_hWnd, RSR_MOVE);*/
    rPhraseStatic.SetInitialPosition(m_phrase_static.m_hWnd, RSR_MOVE);
    rPhrase.SetInitialPosition(m_pwd_ctrl.m_hWnd, RSR_MOVE);
    GetDlgItem(IDC_PHRASE_RADIO, &hWnd);
    rPwdRadio.SetInitialPosition(hWnd, RSR_MOVE);
    GetDlgItem(IDC_DEFAULT_RADIO, &hWnd);
    rDefaultRadio.SetInitialPosition(hWnd, RSR_MOVE);

    rCredentialsStatic.SetInitialPosition(m_credentials_static.m_hWnd, RSR_MOVE);
    rCredPwdStatic.SetInitialPosition(m_cred_pwd_static.m_hWnd, RSR_MOVE);
    rCredPassword.SetInitialPosition(m_cred_password_edit.m_hWnd, RSR_MOVE);
    rCredBox.SetInitialPosition(m_cred_box_static.m_hWnd, RSR_MOVE);
    rCredAccountStatic.SetInitialPosition(m_cred_account_static.m_hWnd, RSR_MOVE);
    rCredAccount.SetInitialPosition(m_cred_account_edit.m_hWnd, RSR_MOVE);

    rForceUpdate.SetInitialPosition(m_force_update_chk.m_hWnd, RSR_MOVE);
    rUpdate.SetInitialPosition(m_update_btn.m_hWnd, RSR_MOVE);
    rUpdateStatic.SetInitialPosition(m_update_static.m_hWnd, RSR_MOVE);
    rUpdateOne.SetInitialPosition(m_update_one_btn.m_hWnd, RSR_MOVE);
    rUpdateOneStatic.SetInitialPosition(m_update_one_static.m_hWnd, RSR_MOVE);
    rStopLightRed.SetInitialPosition(m_stoplight_red.m_hWnd, RSR_MOVE);
    rStopLightYellow.SetInitialPosition(m_stoplight_yellow.m_hWnd, RSR_MOVE);
    rStopLightGreen.SetInitialPosition(m_stoplight_green.m_hWnd, RSR_MOVE);

    rShowHostChk.SetInitialPosition(m_show_host_chk.m_hWnd, RSR_ANCHOR_RIGHT);

    //rHostConfig.SetInitialPosition(m_host_config_edit.m_hWnd, RSR_ANCHOR_RIGHT_STRETCH);
    rHostConfig.SetInitialPosition(m_host_config_edit.m_hWnd, RSR_TOP_ANCHOR | RSR_LEFT_MOVE | RSR_RIGHT_MOVE | RSR_BOTTOM_PROPORTIONAL);
    //rResults.SetInitialPosition(m_results_edit.m_hWnd, RSR_MOVE);
    rResults.SetInitialPosition(m_results_edit.m_hWnd, RSR_LEFT_MOVE | RSR_RIGHT_MOVE | RSR_TOP_PROPORTIONAL | RSR_BOTTOM_MOVE);

    m_host_config_edit.EnableWindow(FALSE);

    // default - choose url
    m_file_radio.SetCheck(0);
    m_url_radio.SetCheck(1);
    m_url_edit.EnableWindow();
    m_anl_btn.EnableWindow();
    m_file_edit.EnableWindow(FALSE);
    m_file_browse_btn.EnableWindow(FALSE);

    // default - use default passphrase
    m_pwd_radio.SetCheck(0);
    m_default_radio.SetCheck(1);
    m_pwd_ctrl.EnableWindow(FALSE);

    SetRedLight();

    char host[100] = "";
    gethostname(host, 100);
    m_hostname = host;
    UpdateData(FALSE);

    OnRefreshBtn();

    return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMPDUpdateDlg::OnPaint() 
{
    if (IsIconic())
    {
	CPaintDC dc(this); // device context for painting
	
	SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
	
	// Center icon in client rectangle
	int cxIcon = GetSystemMetrics(SM_CXICON);
	int cyIcon = GetSystemMetrics(SM_CYICON);
	CRect rect;
	GetClientRect(&rect);
	int x = (rect.Width() - cxIcon + 1) / 2;
	int y = (rect.Height() - cyIcon + 1) / 2;
	
	// Draw the icon
	dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
	CDialog::OnPaint();
    }
}

HCURSOR CMPDUpdateDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

struct FindThreadSingleArg
{
    CListBox *list;
    int i;
    HWND hWnd;
    int port;
    char phrase[100];
};

HANDLE g_hMutex = CreateMutex(NULL, FALSE, NULL);

int WriteString(int bfd, char *str)
{
    return beasy_send(bfd, str, strlen(str)+1);
}

bool ReadString(int bfd, char *str)
{
    int n;
    do {
	n = 0;
	while (!n)
	{
	    n = bread(bfd, str, 1);
	    if (n == SOCKET_ERROR)
	    {
		printf("ReadString[%d] failed, error %d\n", bget_fd(bfd), WSAGetLastError());
		return false;
	    }
	}
    } while (*str++ != '\0');
    return true;
}

bool ReadStringTimeout(int bfd, char *str, int timeout)
{
    int n;
    char *str_orig = str;

    do {
	n = 0;
	while (!n)
	{
	    n = beasy_receive_timeout(bfd, str, 1, timeout);
	    if (n == SOCKET_ERROR)
	    {
		printf("ReadStringTimeout failed, error %d\n", WSAGetLastError());
		return false;
	    }
	    if (n == 0)
	    {
		return false;
	    }
	}
    } while (*str++ != '\0');
    return true;
}

bool ConnectToHost(const char *host, int port, char *pwd, int *pbfd)
{
    int bfd;
    char str[100];
    char phrase[100];
    char *result;
    
    strcpy(phrase, pwd);
    
    if (beasy_create(&bfd, 0, INADDR_ANY) == SOCKET_ERROR)
    {
	printf("beasy_create failed: %d\n", WSAGetLastError());fflush(stdout);
	return false;
    }
    //printf("connecting to %s:%d\n", host, arg->port);fflush(stdout);
    if (beasy_connect_timeout(bfd, (char*)host, port, 10) == SOCKET_ERROR)
    {
	printf("beasy_connect failed: %d\n", WSAGetLastError());fflush(stdout);
	beasy_closesocket(bfd);
	return false;
    }
    if (!ReadStringTimeout(bfd, str, 10))
    {
	printf("reading prepend string failed.\n");fflush(stdout);
	beasy_closesocket(bfd);
	return false;
    }
    strcat(phrase, str);
    WaitForSingleObject(g_hMutex, INFINITE);
    result = crypt(phrase, MPD_SALT_VALUE);
    strcpy(str, result);
    ReleaseMutex(g_hMutex);
    if (WriteString(bfd, str) == SOCKET_ERROR)
    {
	printf("WriteString of the crypt string failed: %d\n", WSAGetLastError());fflush(stdout);
	beasy_closesocket(bfd);
	return false;
    }
    if (!ReadStringTimeout(bfd, str, 10))
    {
	printf("reading authentication result failed.\n");fflush(stdout);
	beasy_closesocket(bfd);
	return false;
    }
    if (strcmp(str, "SUCCESS"))
    {
	printf("authentication request failed.\n");fflush(stdout);
	beasy_closesocket(bfd);
	return false;
    }
    if (WriteString(bfd, "console") == SOCKET_ERROR)
    {
	printf("WriteString failed after attempting passphrase authentication: %d\n", WSAGetLastError());fflush(stdout);
	beasy_closesocket(bfd);
	return false;
    }
    //printf("connected\n");fflush(stdout);
    *pbfd = bfd;
    return true;
}

void FindThreadSingle(FindThreadSingleArg *arg)
{
    TCHAR host[100];
    char str[100];
    int bfd;
    
    if (arg->list->GetText(arg->i, host) == LB_ERR)
    {
	::PostMessage(arg->hWnd, WM_USER+1, arg->i, FALSE);
	delete arg;
	return;
    }
    
    ::PostMessage(arg->hWnd, WM_USER+1, arg->i, TRUE);
    
    if (!ConnectToHost(host, arg->port, arg->phrase, &bfd))
    {
	::PostMessage(arg->hWnd, WM_USER+1, arg->i, FALSE);
	delete arg;
	return;
    }
    
    if (WriteString(bfd, "version") == SOCKET_ERROR)
    {
	printf("WriteString failed after attempting passphrase authentication: %d\n", WSAGetLastError());fflush(stdout);
	beasy_closesocket(bfd);
	::PostMessage(arg->hWnd, WM_USER+1, arg->i, FALSE);
	delete arg;
	return;
    }
    if (!ReadString(bfd, str))
    {
	::PostMessage(arg->hWnd, WM_USER+1, arg->i, FALSE);
	delete arg;
	return;
    }
    WriteString(bfd, "done");
    beasy_closesocket(bfd);
    
    ::PostMessage(arg->hWnd, WM_USER+1, -1, FALSE);
    delete arg;
}

#define FIND_NUM_PER_THREAD MAXIMUM_WAIT_OBJECTS

void OnFindBtnThread(CMPDUpdateDlg *pDlg)
{
    int n;
    DWORD count = pDlg->m_list.GetCount();
    pDlg->m_num_threads = count;

    if (count < 1)
    {
	CloseHandle(pDlg->m_hFindThread);
	pDlg->m_hFindThread = NULL;
	return;
    }

    if (pDlg->m_bNeedPassword)
    {
	CPwdDialog dlg;
	dlg.DoModal();
	if (dlg.m_bUseDefault)
	    strcpy(pDlg->m_pszPhrase, MPD_DEFAULT_PASSPHRASE);
	else
	    strcpy(pDlg->m_pszPhrase, dlg.m_password);
    }

    DWORD dwThreadID;
    HANDLE hThread[FIND_NUM_PER_THREAD];
    int index;
    for (DWORD i=0; i<count; i++)
    {
	FindThreadSingleArg *arg = new FindThreadSingleArg;
	arg->hWnd = pDlg->m_hWnd;
	arg->list = &pDlg->m_list;
	arg->i = i;
	arg->port = pDlg->m_nPort;
	if (strlen(pDlg->m_pszPhrase) < 100)
	    strcpy(arg->phrase, pDlg->m_pszPhrase);
	else
	    arg->phrase[0] = '\0';
	index = i % FIND_NUM_PER_THREAD;
	hThread[index] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)FindThreadSingle, arg, 0, &dwThreadID);
	if (hThread[index] == NULL)
	{
	    pDlg->m_num_threads--;
	    ::PostMessage(arg->hWnd, WM_USER+1, arg->i, FALSE);
	    delete arg;
	}
	if (index == FIND_NUM_PER_THREAD-1)
	{
	    WaitForMultipleObjects(FIND_NUM_PER_THREAD, hThread, TRUE, 120000);
	    for (n=0; n<FIND_NUM_PER_THREAD; n++)
		CloseHandle(hThread[n]);
	}
    }

    CloseHandle(pDlg->m_hFindThread);
    pDlg->m_hFindThread = NULL;
}

void CMPDUpdateDlg::OnFindBtn() 
{
    DWORD dwThreadID;
    HCURSOR hOldCursor = SetCursor( LoadCursor(NULL, IDC_WAIT) );

    SetRedLight();

    m_find_btn.EnableWindow(FALSE);
    m_refresh_btn.EnableWindow(FALSE);
    m_update_btn.EnableWindow(FALSE);
    m_update_one_btn.EnableWindow(FALSE);
    m_edit_add_btn.EnableWindow(FALSE);
    m_verify_btn.EnableWindow(FALSE);

    m_hFindThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)OnFindBtnThread, this, 0, &dwThreadID);
    if (m_hFindThread == NULL)
	MessageBox("Unable to create a Find thread", "Error", MB_OK);
    
    SetCursor(hOldCursor);
}

void CMPDUpdateDlg::OnVerifyBtn() 
{
    int num_hosts;
    char host[100];
    int bfd;
    int *iHosts;
    int i;
    char str[100];
    HCURSOR hOldCursor;
    
    UpdateData();
    
    num_hosts = m_list.GetSelCount();

    // Parse list window and add to host list
    if (num_hosts == 0)
	return;
    
    hOldCursor = SetCursor( LoadCursor(NULL, IDC_WAIT) );

    SetRedLight();

    m_find_btn.EnableWindow(FALSE);
    m_refresh_btn.EnableWindow(FALSE);
    m_update_btn.EnableWindow(FALSE);
    m_update_one_btn.EnableWindow(FALSE);
    m_edit_add_btn.EnableWindow(FALSE);
    m_verify_btn.EnableWindow(FALSE);

    m_num_threads = num_hosts;

    // Create the host list
    iHosts = new int[num_hosts];
    if (m_list.GetSelItems(num_hosts, iHosts) == LB_ERR)
    {
	SetCursor(hOldCursor);
	MessageBox("GetSelItems failed", "Error", MB_OK);
	delete iHosts;
	return;
    }
    if (m_bNeedPassword)
    {
	CPwdDialog dlg;
	dlg.DoModal();
	if (dlg.m_bUseDefault)
	    strcpy(m_pszPhrase, MPD_DEFAULT_PASSPHRASE);
	else
	    strcpy(m_pszPhrase, dlg.m_password);
    }
    for (i=0; i<num_hosts; i++)
    {
	if (m_list.GetText(iHosts[i], host) == LB_ERR)
	{
	    SetCursor(hOldCursor);
	    MessageBox("GetText failed", "Error", MB_OK);
	    delete iHosts;
	    return;
	}

	if (!ConnectToHost(host, m_nPort, m_pszPhrase, &bfd))
	{
	    beasy_closesocket(bfd);
	    ::PostMessage(m_hWnd, WM_USER+1, iHosts[i], FALSE);
	    continue;
	}
	
	if (WriteString(bfd, "version") == SOCKET_ERROR)
	{
	    beasy_closesocket(bfd);
	    ::PostMessage(m_hWnd, WM_USER+1, iHosts[i], FALSE);
	    continue;
	}
	if (!ReadString(bfd, str))
	{
	    beasy_closesocket(bfd);
	    ::PostMessage(m_hWnd, WM_USER+1, iHosts[i], FALSE);
	    continue;
	}
	WriteString(bfd, "done");
	beasy_closesocket(bfd);
	
	::PostMessage(m_hWnd, WM_USER+1, -1, FALSE);
    }
    delete iHosts;
    SetCursor(hOldCursor);
}

#include <lmerr.h>
#include <lmcons.h>
#include <lmapibuf.h>
#include <lmserver.h>

#ifndef LMCSTR
#define LMCSTR LPCWSTR
#endif

void CMPDUpdateDlg::OnRefreshBtn() 
{
    DWORD num_read=0, total=0, size;
    int index;
    SERVER_INFO_100 *pBuf = NULL;
    WCHAR wBuffer[1024] = L"";
    char tBuf[100], tLocalHost[100];
    DWORD ret_val;

    UpdateData();
    SetRedLight();

    HCURSOR hOldCursor = SetCursor( LoadCursor(NULL, IDC_WAIT) );
    
    if (m_domain == "")
    {
	ret_val = NetServerEnum(
	    NULL, 
	    100,
	    (LPBYTE*)&pBuf,
	    MAX_PREFERRED_LENGTH,
	    &num_read,
	    &total,
	    SV_TYPE_NT, 
	    NULL,
	    0);
    }
    else
    {
	WCHAR wDomain[100];
	mbstowcs(wDomain, m_domain, 100);
	ret_val = NetServerEnum(
	    NULL, 
	    100,
	    (LPBYTE*)&pBuf,
	    MAX_PREFERRED_LENGTH,
	    &num_read,
	    &total,
	    SV_TYPE_NT, 
	    (LMCSTR)wDomain,
	    0);
    }
    
    if (ret_val == NERR_Success)
    {
	size = 100;
	GetComputerName(tLocalHost, &size);
	m_list.ResetContent();
	if (num_read == 0)
	{
	    m_list.InsertString(-1, tLocalHost);
	    m_list.SetSel(0);
	}
	else
	{
	    index = -1;
	    for (unsigned int i=0; i<num_read; i++)
	    {
		wcstombs(tBuf, (WCHAR*)pBuf[i].sv100_name, wcslen((WCHAR*)pBuf[i].sv100_name)+1);
		ret_val = m_list.InsertString(-1, tBuf);
		if (stricmp(tBuf, tLocalHost) == 0)
		    index = ret_val;
	    }
	    if (index != -1)
		m_list.SetSel(index);
	}
	NetApiBufferFree(pBuf);
    }
    else
    {
	sprintf(tBuf, "error: %d", ret_val);
	MessageBox(tBuf, "Unable to retrieve network host names");
    }
    
    SetCursor(hOldCursor);
}

void UpdateBtnThread(CMPDUpdateDlg *pDlg)
{
    int i;
    int num_hosts;
    char host[100];
    int bfd;
    bool bDeleteTmpMpd = false;
    bool bFailure = false;
    unsigned int version_new, version_old;
    CString results;

    num_hosts = pDlg->m_host_list.GetCount();
    if (num_hosts == 0)
    {
	CloseHandle(pDlg->m_hUpdateBtnThread);
	pDlg->m_hUpdateBtnThread = NULL;
	return;
    }
    
    if (pDlg->m_bNeedPassword)
    {
	if (pDlg->m_bUseDefault)
	    strcpy(pDlg->m_pszPhrase, MPD_DEFAULT_PASSPHRASE);
	else
	    strcpy(pDlg->m_pszPhrase, pDlg->m_password);
    }

    if (pDlg->m_url_radio.GetCheck())
    {
	if (!pDlg->GetTmpMpdFromURL())
	{
	    pDlg->SetRedLight();
	    if (pDlg->m_bShowHostConfig)
		pDlg->GetHostConfig(NULL);
	    CloseHandle(pDlg->m_hUpdateBtnThread);
	    pDlg->m_hUpdateBtnThread = NULL;
	    return;
	}
	bDeleteTmpMpd = true;
    }

    if (!pDlg->m_bForceUpdate)
    {
	if (!GetLocalVersion(pDlg->m_url_radio.GetCheck() ? pDlg->m_localfile : pDlg->m_filename, version_new))
	{
	    pDlg->SetRedLight();
	    if (bDeleteTmpMpd)
		DeleteFile(pDlg->m_localfile);
	    MessageBox(NULL, "Unable to get the version of the new mpd", "Update aborted", MB_OK);
	    return;
	}
    }

    // gray out the buttons
    PostMessage(pDlg->m_hWnd, WM_USER + 3, 0, 0);

    for (i=0; i<num_hosts; i++)
    {
	if (pDlg->m_host_list.GetText(i, host) == LB_ERR)
	    continue;
	
	if (ConnectToHost(host, pDlg->m_nPort, pDlg->m_pszPhrase, &bfd))
	{
	    char pszError[256];
	    char str[256], str2[256];
	    
	    if (!pDlg->m_bForceUpdate)
	    {
		WriteString(bfd, "version");
		ReadString(bfd, str);
	    }
	    WriteString(bfd, "done");
	    beasy_closesocket(bfd);
	    
	    if (!pDlg->m_bForceUpdate)
	    {
		version_old = mpd_version_string_to_int(str);
		mpd_version_int_to_string(version_old, str);
		mpd_version_int_to_string(version_new, str2);
	    }
	    if (pDlg->m_bForceUpdate || version_old < version_new)
	    {
		if (UpdateMPD(host, pDlg->m_cred_account, pDlg->m_cred_password, pDlg->m_nPort, pDlg->m_pszPhrase, 
		    bDeleteTmpMpd ? pDlg->m_localfile : pDlg->m_filename, pszError, 256))
		{
		    results.Format("%s: success\r\n", host);
		    pDlg->m_results += results;
		    PostMessage(pDlg->m_hWnd, WM_USER + 5, 0, 0);
		}
		else
		{
		    bFailure = true;
		    results.Format("%s: failure, %s\r\n", host, pszError);
		    pDlg->m_results += results;
		    PostMessage(pDlg->m_hWnd, WM_USER + 5, 0, 0);
		    //MessageBox(NULL, pszError, "Unable to update mpd", MB_OK);
		}
	    }
	    else
	    {
		CString s;
		if (version_old == version_new)
		{
		    s.Format("Version <%s> is already installed on %s", str, host);
		    results.Format("%s: no action, <%s> is already installed\r\n", host, str);
		    pDlg->m_results += results;
		    PostMessage(pDlg->m_hWnd, WM_USER + 5, 0, 0);
		    //MessageBox(NULL, s, "Update aborted", MB_OK);
		}
		else
		{
		    s.Format("Version <%s> on %s is newer than version <%s>", str, host, str2);
		    results.Format("%s: no action, <%s> is newer than <%s>\r\n", host, str, str2);
		    pDlg->m_results += results;
		    PostMessage(pDlg->m_hWnd, WM_USER + 5, 0, 0);
		    //MessageBox(NULL, s, "Update aborted", MB_OK);
		}
	    }
	}
	else
	{
	    CString str;
	    bFailure = true;
	    str.Format("Connect to mpd on %s failed", host);
	    results.Format("%s: failure, connect to mpd failed\r\n", host);
	    pDlg->m_results += results;
	    PostMessage(pDlg->m_hWnd, WM_USER + 5, 0, 0);
	    //MessageBox(NULL, str, "Unable to update mpd", MB_OK);
	}
    }

    bFailure ? pDlg->SetRedLight() : pDlg->SetGreenLight();

    PostMessage(pDlg->m_hWnd, WM_USER + 4, 0, 0);

    if (bDeleteTmpMpd)
	DeleteFile(pDlg->m_localfile);

    if (pDlg->m_bShowHostConfig)
    {
	PostMessage(pDlg->m_hWnd, WM_USER+2, 0, 0);
    }

    CloseHandle(pDlg->m_hUpdateBtnThread);
    pDlg->m_hUpdateBtnThread = NULL;
}

void CMPDUpdateDlg::OnUpdateBtn()
{
    DWORD dwThreadID;

    UpdateData();
    m_results = "";
    UpdateData(FALSE);

    if (m_host_list.GetCount() < 1)
    {
	MessageBox("Please add hosts to the list before selecting Update");
	return;
    }

    if (m_bNeedPassword)
    {
	if (m_bUseDefault)
	    strcpy(m_pszPhrase, MPD_DEFAULT_PASSPHRASE);
	else
	    strcpy(m_pszPhrase, m_password);
    }

    if (m_cred_account.GetLength() < 1)
    {
	MessageBox("Please enter the account information before selecting Update");
	m_cred_account_edit.SetFocus();
	return;
    }

    SetYellowLight();
    
    m_hUpdateBtnThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)UpdateBtnThread, this, 0, &dwThreadID);
}

#define BUFSIZE 1024*1024

bool CMPDUpdateDlg::GetTmpMpdFromURL()
{
    char *buffer;
    DWORD num_read;
    char path[MAX_PATH];
    CInternetSession session("MPDUpdate");
    CStdioFile *fin, fout;
    CString str;
    
    if (GetTempPath(MAX_PATH, path))
    {
	if (GetTempFileName(path, "mpd", 0, m_localfile.GetBuffer(MAX_PATH)))
	{
	    m_localfile.ReleaseBuffer();
	    buffer = new char[BUFSIZE];

	    // open session
	    fin = NULL;
	    try {
	    fin = session.OpenURL(m_urlname, 1, INTERNET_FLAG_TRANSFER_BINARY);
	    } catch(...)
	    {
		if (fin == NULL)
		{
		    str.Format("OpenURL(%s) failed, error %d", m_urlname, GetLastError());
		    MessageBox(str, "Error");
		    delete buffer;
		    return false;
		}
		str.Format("OpenURL(%s) failed", m_urlname);
		MessageBox(str, "Error");
		delete buffer;
		return false;
	    }

	    // open local file
	    if (!fout.Open(m_localfile, CFile::modeWrite | CFile::typeBinary))
	    {
		str.Format("Open(%s) failed, error %d", m_localfile, GetLastError());
		fin->Close();
		MessageBox(str, "Error");
		delete buffer;
		return false;
	    }

	    while (true)
	    {
		num_read = fin->Read(buffer, BUFSIZE);
		if (num_read > 0)
		{
		    try {
		    fout.Write(buffer, num_read);
		    } catch(...)
		    {
			str.Format("Write failed, error %d", m_localfile, GetLastError());
			fin->Close();
			MessageBox(str, "Error");
			delete buffer;
			return false;
		    }
		}
		else
		{
		    if (num_read == 0)
		    {
			fin->Close();
			fout.Close();
			delete buffer;
			//MessageBox(m_localfile, "File retrieved");
			return true;
		    }
		    str.Format("Read failed, error %d", GetLastError());
		    MessageBox(str, "Error");
		    fin->Close();
		    CString fname = fout.GetFilePath();
		    fout.Close();
		    try {
		    CFile::Remove(fname);
		    } catch(...) {}
		    delete buffer;
		    return false;
		}
	    }
	}
	str.Format("GetTempFileName failed, error %d", GetLastError());
	MessageBox(str, "Error");
	return false;
    }
    str.Format("GetTempPath failed, error %d", GetLastError());
    MessageBox(str, "Error");
    return false;
}

/*
void CMPDUpdateDlg::GetTmpMpdFromFtp()
{
    char path[MAX_PATH];
    CInternetSession session;
    CFtpSession *pFtp;
    
    if (GetTempPath(MAX_PATH, path))
    {
	if (GetTempFileName(path, "mpd", 0, m_localfile.GetBuffer(MAX_PATH)))
	{
	    m_localfile.ReleaseBuffer();
	    try {
		pFtp = session.GetFtpConnection("ftp.mcs.anl.gov");
		pFtp->GetFile("/pub/mpi/nt/binaries/mpd.exe");
		MessageBox(m_localfile, "File retrieved");
	    } catch (...)
	}
    }
}
*/

bool GetLocalVersion(const char *filename, unsigned int &version)
{
    char line[1024];
    HANDLE hIn, hOut, hErr;
    char err_str[256];
    int error;
    int pid;
    DWORD num_read;
    HANDLE hProcess;

    if (strlen(filename) > 1023)
	return false;

    sprintf(line, "%s -version", filename);
    
    hProcess = LaunchProcess(line, NULL, NULL, &hIn, &hOut, &hErr, &pid, &error, err_str);
    if (hProcess == INVALID_HANDLE_VALUE)
    {
	MessageBox(NULL, err_str, "Unable to launch the new mpd", MB_OK);
	return false;
    }
    line[0] = '\0';

    while (true)
    {
	if (!ReadFile(hErr, line, 1024, &num_read, NULL))
	{
	    sprintf(err_str, "error %d", GetLastError());
	    TerminateProcess(hProcess, -1);
	    break;
	}
	if (num_read > 5)
	    break;
    }
    CloseHandle(hIn);
    CloseHandle(hOut);
    CloseHandle(hErr);
    if (WaitForSingleObject(hProcess, 1000) == WAIT_TIMEOUT)
	TerminateProcess(hProcess, -1);
    CloseHandle(hProcess);

    version = mpd_version_string_to_int(line);
    return (version != 0);
}

void CMPDUpdateDlg::OnUpdateOneBtn() 
{
    int bfd;
    CString sHost;
    int num_hosts;
    bool bDeleteTmpMpd = false;
    unsigned int version_new, version_old;

    UpdateData();
    m_results = "";
    UpdateData(FALSE);

    num_hosts = m_host_list.GetCount();
    if (num_hosts == 0)
    {
	MessageBox("Please add a host to the list before selecting Update");
	return;
    }

    int index = m_host_list.GetCurSel();
    if (index == LB_ERR)
    {
	MessageBox("Please select a host from the list before selecting Update single");
	return;
    }
    m_host_list.GetText(index, sHost);

    if (m_bNeedPassword)
    {
	if (m_bUseDefault)
	    strcpy(m_pszPhrase, MPD_DEFAULT_PASSPHRASE);
	else
	    strcpy(m_pszPhrase, m_password);
    }

    if (m_cred_account.GetLength() < 1)
    {
	MessageBox("Please enter the account information before selecting Update");
	m_cred_account_edit.SetFocus();
	return;
    }

    SetYellowLight();

    HCURSOR hOldCursor = SetCursor( LoadCursor(NULL, IDC_WAIT) );
    
    if (m_url_radio.GetCheck())
    {
	if (!GetTmpMpdFromURL())
	{
	    SetRedLight();
	    SetCursor(hOldCursor);
	    if (m_bShowHostConfig)
		GetHostConfig(NULL);
	    m_results.Format("%s: failure", sHost);
	    UpdateData(FALSE);
	    return;
	}
	bDeleteTmpMpd = true;
    }

    if (!m_bForceUpdate)
    {
	if (!GetLocalVersion(m_url_radio.GetCheck() ? m_localfile : m_filename, version_new))
	{
	    SetRedLight();
	    if (bDeleteTmpMpd)
		DeleteFile(m_localfile);
	    SetCursor(hOldCursor);
	    m_results.Format("%s: failure", sHost);
	    UpdateData(FALSE);
	    MessageBox("Unable to get the version of the new mpd", "Update aborted");
	    return;
	}
    }

    if (ConnectToHost(sHost, m_nPort, m_pszPhrase, &bfd))
    {
	char pszError[256];
	char str[256], str2[256];
	
	if (!m_bForceUpdate)
	{
	    WriteString(bfd, "version");
	    ReadString(bfd, str);
	}
	WriteString(bfd, "done");
	beasy_closesocket(bfd);

	if (!m_bForceUpdate)
	{
	    version_old = mpd_version_string_to_int(str);
	    mpd_version_int_to_string(version_old, str);
	    mpd_version_int_to_string(version_new, str2);
	}
	if (m_bForceUpdate || (version_old < version_new))
	{
	    if (UpdateMPD(sHost, m_cred_account, m_cred_password, m_nPort, m_pszPhrase, 
		m_url_radio.GetCheck() ? m_localfile : m_filename, pszError, 256))
	    {
		SetGreenLight();
		m_results.Format("%s: success", sHost);
		UpdateData(FALSE);
	    }
	    else
	    {
		SetRedLight();
		m_results.Format("%s: failure, %s", sHost, pszError);
		UpdateData(FALSE);
		MessageBox(pszError, "Unable to update mpd");
	    }
	}
	else
	{
	    CString s;
	    if (version_old == version_new)
	    {
		s.Format("Version <%s> is already installed on %s", str, sHost);
		MessageBox(s, "Update aborted");
	    }
	    else
	    {
		s.Format("Version <%s> on %s is newer than version <%s>", str, sHost, str2);
		MessageBox(s, "Update aborted");
	    }
	    SetRedLight();
	    m_results.Format("%s: no action\r\n%s", sHost, s);
	    UpdateData(FALSE);
	}
    }
    else
    {
	SetRedLight();
	CString str;
	str.Format("Connect to mpd on %s failed", sHost);
	m_results.Format("%s: failure", sHost);
	UpdateData(FALSE);
	MessageBox(str, "Unable to update mpd");
    }

    if (bDeleteTmpMpd)
    {
	DeleteFile(m_localfile);
    }

    SetCursor(hOldCursor);

    if (m_bShowHostConfig)
	GetHostConfig(NULL);
}

LRESULT CMPDUpdateDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
    if (message == WM_USER+1)
    {
	if (lParam)
	    m_list.SetSel((int)wParam, TRUE);
	else
	{
	    if ((int)wParam != -1)
		m_list.SetSel((int)wParam, FALSE);
	    m_num_threads--;
	    if (m_num_threads == 0)
	    {
		m_find_btn.EnableWindow();
		m_refresh_btn.EnableWindow();
		m_update_btn.EnableWindow();
		m_update_one_btn.EnableWindow();
		m_edit_add_btn.EnableWindow();
		m_verify_btn.EnableWindow();
	    }
	}
    }
    if (message == WM_USER + 2)
    {
	GetHostConfig(NULL);
    }
    if (message == WM_USER + 3)
    {
	m_find_btn.EnableWindow(FALSE);
	m_refresh_btn.EnableWindow(FALSE);
	m_update_btn.EnableWindow(FALSE);
	m_update_one_btn.EnableWindow(FALSE);
	m_edit_add_btn.EnableWindow(FALSE);
	m_verify_btn.EnableWindow(FALSE);
    }
    if (message == WM_USER + 4)
    {
	m_find_btn.EnableWindow();
	m_refresh_btn.EnableWindow();
	m_update_btn.EnableWindow();
	m_update_one_btn.EnableWindow();
	m_edit_add_btn.EnableWindow();
	m_verify_btn.EnableWindow();
    }
    if (message == WM_USER + 5)
    {
	UpdateData(FALSE);
    }
    return CDialog::WindowProc(message, wParam, lParam);
}

void CMPDUpdateDlg::OnEditAddBtn() 
{
    int i;
    int *iHosts;
    int num_hosts = m_list.GetSelCount();
    char host[100];
    
    // Add hostname to host list
    UpdateData();
    SetRedLight();
    
    if (m_hostname.GetLength() != 0)
    {
	
	CString str;
	int n = m_host_list.GetCount();
	if (n != LB_ERR)
	{
	    bool bFound = false;
	    for (int i=0; i<n; i++)
	    {
		m_host_list.GetText(i, str);
		if (str.CompareNoCase(m_hostname) == 0)
		{
		    bFound = true;
		    //break;
		}
	    }
	    if (!bFound)
	    {
		m_host_list.InsertString(-1, m_hostname);
	    }
	}
    }

    // Parse list window and add to host list
    if (num_hosts == 0)
	return;
    
    // Create the host list
    iHosts = new int[num_hosts];
    if (m_list.GetSelItems(num_hosts, iHosts) == LB_ERR)
    {
	MessageBox("GetSelItems failed", "Error", MB_OK);
	delete iHosts;
	return;
    }
    for (i=0; i<num_hosts; i++)
    {
	if (m_list.GetText(iHosts[i], host) == LB_ERR)
	{
	    MessageBox("GetText failed", "Error", MB_OK);
	    delete iHosts;
	    return;
	}
	CString str;
	int n = m_host_list.GetCount();
	if (n != LB_ERR)
	{
	    bool bFound = false;
	    for (int i=0; i<n; i++)
	    {
		m_host_list.GetText(i, str);
		if (str.CompareNoCase(host) == 0)
		{
		    bFound = true;
		}
	    }
	    if (!bFound)
	    {
		m_host_list.InsertString(-1, host);
	    }
	}
    }
    delete iHosts;
}

int CMPDUpdateDlg::OnVKeyToItem(UINT nKey, CListBox* pListBox, UINT nIndex) 
{
    if (*pListBox == m_host_list)
    {
	if (nKey == VK_DELETE)
	{
	    int index = m_host_list.GetCurSel();
	    if (index != LB_ERR)
	    {
		m_host_list.DeleteString(index);
		if (m_host_list.SetCurSel(index) == LB_ERR)
		    m_host_list.SetCurSel(index-1);
		SetRedLight();
	    }
	}
    }
	return CDialog::OnVKeyToItem(nKey, pListBox, nIndex);
}

void CMPDUpdateDlg::OnClose() 
{
    if (m_hUpdateBtnThread)
    {
	TerminateThread(m_hUpdateBtnThread, -1);
	m_hUpdateBtnThread = NULL;
    }
    if (m_hFindThread)
    {
	TerminateThread(m_hFindThread, -1);
	m_hFindThread = NULL;
    }
    bsocket_finalize();
	CDialog::OnClose();
}

void CMPDUpdateDlg::OnSize(UINT nType, int cx, int cy) 
{
    CDialog::OnSize(nType, cx, cy);

    if (nType != SIZE_MINIMIZED)
    {
	/*
	if (m_nMinWidth != -1)
	{
	    if (cx < m_nMinWidth || cy < m_nMinHeight)
	    {
		RECT r, r2;
		r.left = 0;
		r.top = 0;
		r.right = m_nMinWidth;
		r.bottom = m_nMinHeight;
		AdjustWindowRect(&r, WS_CHILD, FALSE);
		GetWindowRect(&r2);
		MoveWindow(r2.left, r2.top, r.right-r.left, r.bottom-r.top, TRUE);
	    }
	}
	*/

	if (m_nMinWidth <= cx || m_nMinHeight <= cy)
	{
	    if (cx < m_nMinWidth)
		cx = m_nMinWidth;
	    if (cy < m_nMinHeight)
		cy = m_nMinHeight;

	    r1Static.Resize(cx, cy);
	    rList.Resize(cx, cy);
	    rOk.Resize(cx, cy);
	    rCancel.Resize(cx, cy);
	    rBox.Resize(cx, cy);
	    rRefresh.Resize(cx, cy);
	    rDomain.Resize(cx, cy);
	    rStatic.Resize(cx, cy);
	    
	    rSourceStatic.Resize(cx, cy);
	    rFileRadio.Resize(cx, cy);
	    rFileName.Resize(cx, cy);
	    rFileBrowse.Resize(cx, cy);
	    rURLRadio.Resize(cx, cy);
	    rURL.Resize(cx, cy);
	    rANL.Resize(cx, cy);

	    rPhraseStatic.Resize(cx, cy);
	    /*rPwdStatic.Resize(cx, cy);*/
	    r2Static.Resize(cx, cy);
	    rPhrase.Resize(cx, cy);
	    rPwdRadio.Resize(cx, cy);
	    rDefaultRadio.Resize(cx, cy);
	    rUpdate.Resize(cx, cy);
	    rUpdateStatic.Resize(cx, cy);
	    rUpdateOne.Resize(cx, cy);
	    rUpdateOneStatic.Resize(cx, cy);
	    rStopLightRed.Resize(cx, cy);
	    rStopLightYellow.Resize(cx, cy);
	    rStopLightGreen.Resize(cx, cy);

	    rCredentialsStatic.Resize(cx, cy);
	    rCredPwdStatic.Resize(cx, cy);
	    rCredPassword.Resize(cx, cy);
	    rCredBox.Resize(cx, cy);
	    rCredAccountStatic.Resize(cx, cy);
	    rCredAccount.Resize(cx, cy);

	    rShowHostChk.Resize(cx, cy);
	    rHostConfig.Resize(cx, cy);

	    rResults.Resize(cx, cy);
	    rForceUpdate.Resize(cx, cy);
	    
	    Invalidate();
	}
    }
}

void CMPDUpdateDlg::OnPhraseRadio() 
{
    m_bUseDefault = false;
    m_pwd_ctrl.EnableWindow();
    SetRedLight();
}

void CMPDUpdateDlg::OnDefaultPwdRadio() 
{
    m_bUseDefault = true;
    m_pwd_ctrl.EnableWindow(FALSE);
    SetRedLight();
}

void CMPDUpdateDlg::SetRedLight()
{
    m_stoplight_red.ShowWindow(SW_SHOW);
    m_stoplight_yellow.ShowWindow(SW_HIDE);
    m_stoplight_green.ShowWindow(SW_HIDE);
}

void CMPDUpdateDlg::SetGreenLight()
{
    m_stoplight_red.ShowWindow(SW_HIDE);
    m_stoplight_yellow.ShowWindow(SW_HIDE);
    m_stoplight_green.ShowWindow(SW_SHOW);
}

void CMPDUpdateDlg::SetYellowLight()
{
    m_stoplight_red.ShowWindow(SW_HIDE);
    m_stoplight_yellow.ShowWindow(SW_SHOW);
    m_stoplight_green.ShowWindow(SW_HIDE);
}

void CMPDUpdateDlg::OnShowHostChk() 
{
    UpdateData();

    m_host_config_edit.EnableWindow(m_bShowHostConfig);
    if (m_bShowHostConfig)
	GetHostConfig(NULL);
}

void CMPDUpdateDlg::OnSelchangeHostList() 
{
    UpdateData();
    if (m_bShowHostConfig)
    {
	CString host;
	int index = m_host_list.GetCurSel();
	if (index != LB_ERR)
	{
	    m_host_list.GetText(index, host);
	    GetHostConfig(host);
	}
    }
}

void CMPDUpdateDlg::GetHostConfig(const char *host)
{
    CString sHost;
    int bfd;
    char pszStr[MAX_CMD_LENGTH] = "mpd not installed";

    UpdateData();

    if (host == NULL)
    {
	int index = m_host_list.GetCurSel();
	if (index == LB_ERR)
	    return;
	m_host_list.GetText(index, sHost);
    }
    else
	sHost = host;

    if (m_bNeedPassword)
    {
	if (m_bUseDefault)
	    strcpy(m_pszPhrase, MPD_DEFAULT_PASSPHRASE);
	else
	    strcpy(m_pszPhrase, m_password);
    }
    
    HCURSOR hOldCursor = SetCursor( LoadCursor(NULL, IDC_WAIT) );
    
    if (ConnectToHost(sHost, m_nPort, m_pszPhrase, &bfd))
    {
	WriteString(bfd, "config");
	ReadString(bfd, pszStr);
	WriteString(bfd, "done");
	beasy_closesocket(bfd);
	
	m_host_config = sHost + ":\n";
	m_host_config += pszStr;
	m_host_config.Replace("\n", "\r\n");
    }
    else
    {
	m_host_config = sHost + ":\r\n" + pszStr;
    }
    
    SetCursor(hOldCursor);
    UpdateData(FALSE);
}

void CMPDUpdateDlg::OnAnlBtn() 
{
    UpdateData();
    SetRedLight();
    m_urlname = "ftp://ftp.mcs.anl.gov/pub/mpi/nt/binaries/mpd.exe";
    UpdateData(FALSE);
}

void CMPDUpdateDlg::OnFileBrowseBtn() 
{
    UpdateData();
    SetRedLight();
    CFileDialog f(
	TRUE, "*.exe", m_filename, 
	OFN_HIDEREADONLY | OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST,
	"Executables (*.exe)|*.exe|All files (*.*)|*.*||"
	);
    if (f.DoModal() == IDOK)
    {
	POSITION p;
	p = f.GetStartPosition();
	m_filename = f.GetNextPathName(p);
	UpdateData(FALSE);
    }
}

void CMPDUpdateDlg::OnURLRadio() 
{
    UpdateData();
    SetRedLight();
    if (m_url_radio.GetCheck())
    {
	m_url_edit.EnableWindow();
	m_anl_btn.EnableWindow();
	m_file_edit.EnableWindow(FALSE);
	m_file_browse_btn.EnableWindow(FALSE);
    }
    else
    {
	m_url_edit.EnableWindow(FALSE);
	m_anl_btn.EnableWindow(FALSE);
	m_file_edit.EnableWindow();
	m_file_browse_btn.EnableWindow();
    }
}

void CMPDUpdateDlg::OnFileRadio() 
{
    UpdateData();
    SetRedLight();
    if (m_file_radio.GetCheck())
    {
	m_file_edit.EnableWindow();
	m_file_browse_btn.EnableWindow();
	m_url_edit.EnableWindow(FALSE);
	m_anl_btn.EnableWindow(FALSE);
    }
    else
    {
	m_file_edit.EnableWindow(FALSE);
	m_file_browse_btn.EnableWindow(FALSE);
	m_url_edit.EnableWindow();
	m_anl_btn.EnableWindow();
    }
}
